//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3768133EF958.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3768133EF958.cm

//## begin module%3768133EF958.cp preserve=no
//## end module%3768133EF958.cp

//## Module: ComponentCreator%3768133EF958; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Model/Component/ComponentCreator.cxx

//## begin module%3768133EF958.additionalIncludes preserve=no
//## end module%3768133EF958.additionalIncludes

//## begin module%3768133EF958.includes preserve=yes
// componentCreator
//## end module%3768133EF958.includes

// Component
#include <XSModel/Model/Component/Component.h>
// AddTableComponent
#include <XSModel/Model/Component/AddTableComponent.h>
// MulTableComponent
#include <XSModel/Model/Component/MulTableComponent.h>
// ConComponent
#include <XSModel/Model/Component/ConComponent.h>
// MixComponent
#include <XSModel/Model/Component/MixComponent.h>
// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// ComponentCreator
#include <XSModel/Model/Component/ComponentCreator.h>


//## begin module%3768133EF958.declarations preserve=no
//## end module%3768133EF958.declarations

//## begin module%3768133EF958.additionalDeclarations preserve=yes
#include <XSModel/Model/Component/ComponentBase.h>
#include <XSModel/Model/Component/ACNComponent.h>
#include <memory>
//## end module%3768133EF958.additionalDeclarations


// Class ComponentCreator 

ComponentCreator::ComponentCreator()
  //## begin ComponentCreator::ComponentCreator%3666C1D2F21C_const.hasinit preserve=yes
  : m_component(0)
  //## end ComponentCreator::ComponentCreator%3666C1D2F21C_const.hasinit
  //## begin ComponentCreator::ComponentCreator%3666C1D2F21C_const.initialization preserve=yes
  //## end ComponentCreator::ComponentCreator%3666C1D2F21C_const.initialization
{
  //## begin ComponentCreator::ComponentCreator%3666C1D2F21C_const.body preserve=yes
  //## end ComponentCreator::ComponentCreator%3666C1D2F21C_const.body
}


ComponentCreator::~ComponentCreator()
{
  //## begin ComponentCreator::~ComponentCreator%3666C1D2F21C_dest.body preserve=yes
  //## end ComponentCreator::~ComponentCreator%3666C1D2F21C_dest.body
}



//## Other Operations (implementation)
Component* ComponentCreator::GetComponent (const string& name, CGroupBase* group)
{
  //## begin ComponentCreator::GetComponent%376812C9F7A8.body preserve=yes
        if (m_component == 0)  {m_component =  Make(name, group);} return m_component;
  //## end ComponentCreator::GetComponent%376812C9F7A8.body
}

Component* ComponentCreator::GetComponent (const string& id, CGroupBase* group, const string& type, int table)
{
  //## begin ComponentCreator::GetComponent%376812C9F7AA.body preserve=yes
        if (m_component == 0)  {m_component =  Make(id, group, type,  table);} return m_component;
  //## end ComponentCreator::GetComponent%376812C9F7AA.body
}

Component* ComponentCreator::Make (const string& name, CGroupBase* group)
{
  //## begin ComponentCreator::Make%376812C9F7AF.body preserve=yes
    // virtual constructor method for components. The getSetupData
  // function reads the type from the model.dat or table model file
  // (or any other component construction methods that might be added).
  // After the component is constructed there is enough information to read the
  // component information and the details of its parameters.
        
        
  
  Component::getSetupData(name);
  std::auto_ptr<Component> cp;
  const string type = Component::currentType();
  const bool table  = Component::currentIsTable();
  if (type == "add") 
  {
          if (table) cp.reset(new AddTableComponent(group));
          else cp.reset(new AddComponent(group));
  }
  if (type == "mul")  
  {
          if (table) cp.reset(new MulTableComponent(group));
          else cp.reset(new MulComponent(group));
  }
  if (type == "con") cp.reset(new ConComponent(group));
  if (type == "acn") cp.reset(new ACNComponent(group));
  if (type == "mix") cp.reset(new MixComponent(group));
  
  // the ctor for the components should throw a YellowAlert exception
  // if anything went wrong before this. So should the Component::read
  // function.

  cp->read();
  
  return cp.release();

  //## end ComponentCreator::Make%376812C9F7AF.body
}

Component* ComponentCreator::Make (const string& idstring, CGroupBase* group, const string& type, int table)
{
  //## begin ComponentCreator::Make%376812C9F7B1.body preserve=yes
  // This alternate form of the Make function allows the creation of empty components
// of specified class. It is used for creating a "container" for a computed component
// group. The formal "name" argument is called idstring here to stress the fact that
// this function is not used for creating a proper component, but an internal temporary
// labelled by an identifier.

// This function is most likely to be called for an additive (non-table) Component
// but has been written to be capable of returning a pointer to any type of component.
// Note also that this also creates an empty component unlike the two argument version that
// also reads the model.

        Component* cp;
        if (type == "add") 
        {
                if (table) cp =  new AddTableComponent(group);
                else cp = new AddComponent(group);
        }
        if (type == "mul")  
        {
                if (table) cp =  new MulTableComponent(group);
                else cp = new MulComponent(group);
        }        
        if (type == "con") cp =  new ConComponent(group);
        if (type == "mix") cp =  new MixComponent(group);
        if (type == "sum") cp =  new SumComponent(group);
        cp->name(idstring);
        return cp;
  //## end ComponentCreator::Make%376812C9F7B1.body
}

// Additional Declarations
  //## begin ComponentCreator%3666C1D2F21C.declarations preserve=yes
  //## end ComponentCreator%3666C1D2F21C.declarations

//## begin module%3768133EF958.epilog preserve=yes
//## end module%3768133EF958.epilog
